<!DOCTYPE html>
<html>
	<head>
		<title>Suivi du baromètre</title>
		<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/4.4.1/chart.umd.min.js"></script>
	</head>
<body>
<?php
$base = new SQlite3('barometre.sqlite');

$villes_ALM_SQLITE = $base->query("SELECT code_INSEE FROM Villes");
$villes_ALM = array();
while ($line = $villes_ALM_SQLITE->fetchArray(SQLITE3_NUM)) {
	$villes_ALM[] = $line[0];
}
$json_address = "https://www.barometre-velo.fr/stats/progress.geojson";


// Mise à jour des données
$last_check = $base->querySingle("SELECT last FROM last_check");
if ($last_check ===null || date_add(new DateTime($last_check), DateInterval::createFromDateString('1 hour'))   < new DateTime()) {
	$json = file_get_contents($json_address);
	if ($json !== false) {
		$decoded = json_decode($json, true);
		foreach($decoded['features'] as $value) {
			if(in_array($value['properties']['insee'], $villes_ALM)) {
				$ville = $base->querySingle("SELECT * FROM Villes WHERE code_INSEE=".$value['properties']['insee'].";", true);
				if ($ville == array()) {
					$base->query("INSERT INTO Villes VALUES (".$value['properties']['insee'].", \"".$value['properties']['name']."\");");
				}
				$base->query("INSERT INTO chiffres VALUES(\"".$decoded['date']."\", ".$value['properties']['insee'].", ".$value['properties']['contributions'].");");
			}
		}
		$base->query("DELETE FROM last_check;");
		$base->query("INSERT INTO last_check VALUES ('".$decoded['date']."');");
		$last_check = $decoded['date'];
	}

}

// Comptage et affichage
$compte = $base->querySingle("SELECT SUM(nombre) FROM chiffres WHERE date = \"".$last_check."\";");
?>
<p>Heure du relevé : <b><?=date_format(date_create($last_check),"d/m/Y H:i:s")?></b></p>
<p>Total des réponses pour ALM : <b><?=$compte?></b></p>
<hr/>
<table border="1">
	<thead>
		<tr><th>Ville</th><th>Nombre de réponses</th><th>Chiffres de 2021</th></tr>
	</thead>
<?php
$compte = $base->query("SELECT r1.nom as nom, r1.nombre as nombre, r2.nombre as nombre2021, r1.population as population FROM (SELECT * FROM chiffres c NATURAL JOIN Villes v WHERE c.date = '".$last_check."' ORDER BY c.nombre DESC) r1 LEFT JOIN (SELECT * FROM chiffres_2021) r2 ON r1.code_INSEE = r2.code_INSEE ORDER BY nombre desc");
while( $line = $compte->fetchArray()) {
	$plus_que_2021 = $line['nombre'] > $line['nombre2021'];
	$presque_plus_que_2021 = $line['nombre'] > 0.8 * $line['nombre2021'];
	$seuil = $line['population'] <= 3000 ? 30 : 50 ;
	$qualifie = $line['nombre'] >= $seuil;
	$presque_qualifie = $line['nombre'] >= 0.8 * $seuil;
	?><tr>
		<td<?php if ($plus_que_2021): ?> style="background-color:lightgreen;"<?php elseif ($presque_plus_que_2021): ?> style="background-color:lightgoldenrodyellow;"<?php endif; ?>><?=$line['nom']?></td>
		<td style="text-align: right;<?php if($qualifie): ?> background-color: lightgreen;<?php elseif($presque_qualifie): ?> background-color: lightgoldenrodyellow;<?php else: ?> background-color: lightsalmon;<?php endif; ?>"><?=$line['nombre']?></td>
		<td style="text-align: right;"><?=$line['nombre2021']?></td>
	</tr>
	<?php
}
?></table>
<hr/>
<div style="width: 75%; margin:0 auto;"><canvas id="graphe"></canvas></div>
<?php
$data = $base->query("SELECT * FROM chiffres c natural join villes v WHERE v.nom != 'Angers'");
$dataset = [];
while($line = $data->fetchArray()) {
	if (!key_exists($line['code_INSEE'], $dataset)) {
		$dataset[$line['code_INSEE']]['type'] = 'line';
		$dataset[$line['code_INSEE']]['label'] = $line['nom'];
		$dataset[$line['code_INSEE']]['tension'] = 0.1;
	}
	$dataset[$line['code_INSEE']]['data'][] = array('x' => date_format(date_create($line['date']), 'Y/m/d H:i'), 'y'=>$line['nombre']);
}
$decoded = [];
foreach($dataset as $value) { $decoded[] = $value; }
$json = json_encode($decoded);
?>
<script type="text/javascript">
const data = <?=$json?>;
(async function() {
	const myChart = new Chart(document.getElementById('graphe'), {
		type: 'line',
		data: {
			datasets : data
		}
	});
})();
</script>
<hr/>
<div style="width: 75%; margin:0 auto;"><canvas id="graphe_angers"></canvas></div>
<?php
$data = $base->query("SELECT * FROM chiffres c natural join villes v WHERE v.nom == 'Angers'");
$dataset_angers = [];
while($line = $data->fetchArray()) {
	$dataset_angers[] = array('x' => date_format(date_create($line['date']), 'Y/m/d H:i'), 'y'=>$line['nombre']);
}
$json_angers = json_encode($dataset_angers);
$data = $base->query("SELECT date, SUM(nombre) as nombre FROM chiffres GROUP BY date");
$dataset_tout = [];
while($line = $data->fetchArray()) {
	$dataset_tout[] = array('x' => date_format(date_create($line['date']), 'Y/m/d H:i'), 'y'=>$line['nombre']);
}
$json_tout = json_encode($dataset_tout);
?>
<script type="text/javascript">
const data_angers = <?=$json_angers?>;
const data_tout = <?=$json_tout?>;
(async function() {
	const myChart = new Chart(document.getElementById('graphe_angers'), { 
		type:'line', 
		data: { 
			datasets: [{
				type: 'line',
				label:"Angers",
				data: data_angers,
				tension: 0.1
			},
			{
				type: 'line',
				label: "Agglomération entière",
				data: data_tout,
				tension: 0.1
			}]
		}
	});
})();
</script>
<hr/>
<div style="position: fixed; bottom:0; width:100%;">
<a href="https://git.fedaya.net/Fedaya/progression_barometre">Le code correspondant au script</a>
</div>
</body>
</html>