# La table pour détermination de la nécessité d'une mise à jour
CREATE TABLE last_check (
    last DATETIME
);

# La table qui associe les code_INSEE aux villes
CREATE TABLE Villes (
    code_INSEE SMALL INT PRIMARY KEY,
    nom VARCHAR(255)
);
INSERT INTO "Villes"(code_INSEE,nom) VALUES(49214,'Montreuil-Juigné'),(49055,'Cantenay-Épinard'),(49241,'Le Plessis-Grammoire'),(49298,'Saint-Léger-de-Linières'),(49007,'Angers'),(49015,'Avrillé'),(49307,'Loire-Authion'),(49035,'Bouchemaine'),(49020,'Beaucouzé'),(49278,'Sainte-Gemmes-sur-Loire'),(49223,'Mûrs-Erigné'),(49200,'Longuenée-en-Anjou'),(49267,'Saint-Barthélemy-d''Anjou'),(49353,'Trélazé'),(49135,'Feneu'),(49329,'Savennières'),(49246,'Les Ponts-de-Cé'),(49048,'Briollay'),(49306,'Saint-Martin-du-Fouilloux'),(49377,'Rives-du-Loir-en-Anjou'),(49338,'Soulaines-sur-Aubance'),(49294,'Saint-Lambert-la-Potherie'),(49339,'Soulaire-et-Bourg'),(49323,'Verrières-en-Anjou'),(49271,'Saint-Clément-de-la-Place'),(49028,'Béhuard'),(49130,'Écuillé'),(49326,'Sarrigné'),(49129, 'Écouflant');

# Une table pour stocker les chiffres de 2025, au fur et à mesure qu'ils arrivent
CREATE TABLE chiffres (
    date DATETIME,
    code_INSEE SMALL INT,
    nombre INTEGER,
    PRIMARY KEY( date, code_INSEE),
    FOREIGN KEY(code_INSEE) REFERENCES Villes(code_INSEE)
);

# Une table pour stocker les chiffres de 2021
CREATE TABLE chiffres_2021 (
    code_INSEE SMALL INT,
    nombre INTEGER,
    PRIMARY KEY (code_INSEE),
    FOREIGN KEY (code_INSEE) REFERENCES Villes(code_INSEE)
);

# Qualifiés en 2021
INSERT INTO chiffres_2021 VALUES 
    (49267, 69),
    (49214, 58),
    (49015, 70),
    (49007, 1193),
    (49329, 52),
    (49246, 116),
    (49020, 92),
    (49135, 60),
    (49278, 56),
    (49055, 76),
    (49377, 52),
    (49323,67),
    (49035, 76),
    (49271, 49),
    (49223, 56),
    (49307, 86),
    (49353, 70);

# Non qualifiés en 2021
INSERT INTO chiffres_2021 VALUES
    (49028, 4),
    (49048, 9),
    (49129, 12),
    (49130, 1),
    (49200, 6),
    (49241, 8),
    (49294, 2),
    (49298, 24).
    (49306, 2),
    (49338, 3),
    (49339, 3);


# Ajout des chiffres de population municipale
ALTER TABLE Villes
    ADD population UNSIGNED INT NULL;
UPDATE Villes SET population = 157175 WHERE code_INSEE = 49007;
UPDATE Villes SET population = 14938 WHERE code_INSEE = 49015;
UPDATE Villes SET population = 5557 WHERE code_INSEE = 49020;
UPDATE Villes SET population = 122 WHERE code_INSEE = 49028;
UPDATE Villes SET population = 6690 WHERE code_INSEE = 49035;
UPDATE Villes SET population = 3151 WHERE code_INSEE = 49048;
UPDATE Villes SET population = 2380 WHERE code_INSEE = 49055;
UPDATE Villes SET population = 4475 WHERE code_INSEE = 49129;
UPDATE Villes SET population = 667 WHERE code_INSEE = 49130;
UPDATE Villes SET population = 2202 WHERE code_INSEE = 49135;
UPDATE Villes SET population = 6334 WHERE code_INSEE = 49200;
UPDATE Villes SET population = 7842 WHERE code_INSEE = 49214;
UPDATE Villes SET population = 5935 WHERE code_INSEE = 49223;
UPDATE Villes SET population = 2622 WHERE code_INSEE = 49241;
UPDATE Villes SET population = 12725 WHERE code_INSEE = 49246;
UPDATE Villes SET population = 9460 WHERE code_INSEE = 49267;
UPDATE Villes SET population = 2109 WHERE code_INSEE = 49271;
UPDATE Villes SET population = 3552 WHERE code_INSEE = 49278;
UPDATE Villes SET population = 2949 WHERE code_INSEE = 49294;
UPDATE Villes SET population = 3804 WHERE code_INSEE = 49298;
UPDATE Villes SET population = 1681 WHERE code_INSEE = 49306;
UPDATE Villes SET population = 16416 WHERE code_INSEE = 49307;
UPDATE Villes SET population = 7775 WHERE code_INSEE = 49323;
UPDATE Villes SET population = 848 WHERE code_INSEE = 49326;
UPDATE Villes SET population = 1349 WHERE code_INSEE = 49329;
UPDATE Villes SET population = 1371 WHERE code_INSEE = 49338;
UPDATE Villes SET population = 1489 WHERE code_INSEE = 49339;
UPDATE Villes SET population = 15358 WHERE code_INSEE = 49353;
UPDATE Villes SET population = 5641 WHERE code_INSEE = 49377;